public final class Node {
  public final int nodeID;
  public long count; // long for reconstruction
  public final int cmid;
  public final int pathNum;
  public final NodeType type;
  public boolean isSpecial;
  public final Node parent;
  public Node firstChild;
  public Node nextSibling;
   
  public Node(int nodeID, int cmid, int pathNum, NodeType type, boolean isSpecial, long count, Node parent) {
    if (nodeID>0) this.nodeID=nodeID;
    else this.nodeID=this.hashCode();
    this.cmid=cmid;
    this.pathNum=pathNum;
    this.type=type;
    this.isSpecial=isSpecial;
    this.firstChild=null;
    this.nextSibling=null;    
    this.count=count;
    this.parent=parent;
  }
  
  public final static Node cloneBLPPNode(Node blppNode) {
    return new Node(blppNode.nodeID, blppNode.cmid, blppNode.pathNum, NodeType.BLPP, false, blppNode.count, null);    
  }    
  
  public static void cleanTree(Node root) {
    if (root==null) return;
    for (Node child=root.firstChild; child!=null; ) {
      Node tmp = child.nextSibling;
      cleanTree(child);
      child = tmp;
    }  
    root.firstChild=null;
    root.nextSibling=null;          
  }   
  
}
